local function contact_window()
require "import"
import "android.widget.GridView"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.preference.PreferenceManager"
import "android.widget.Toast"
import "java.io.File"
import "java.io.FileReader"
import "java.io.FileWriter"
import "java.io.BufferedReader"

local languageCodes = dofile("/storage/emulated/0/解说/Plugins/Voice caller/Contact.lua")
local selectedLanguage = nil
local items = {}

-- Collect languages and sort them alphabetically
local sortedLanguages = {}
for lang, _ in pairs(languageCodes) do
    sortedLanguages[#sortedLanguages + 1] = lang
end
table.sort(sortedLanguages)

-- Add sorted languages to the items array
for _, lang in ipairs(sortedLanguages) do
    items[#items + 1] = lang
end

-- Custom order for specific languages
local languagesOrder = {
    -- Your custom order items here
}

local customOrderItems = {}
for _, lang in ipairs(languagesOrder) do
    for i = 1, #items do
        if items[i] == lang then
            customOrderItems[#customOrderItems + 1] = items[i]
        end
    end
end

local layout = {
    GridView,
    id = "grid",
    numColumns = 1,
    background = "#000000", -- black color code
    layout_width = "fill",
    layout_height = "fill"
}

local dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, items)

-- Check if language has been selected before
local sharedPrefs = PreferenceManager.getDefaultSharedPreferences(this)
local storedLanguage = sharedPrefs.getString("selectedLanguage", nil)
if storedLanguage and languageCodes[storedLanguage] then
    selectedLanguage = storedLanguage
else
    dlg.setTitle("contacts")
end

dlg.setButton("Exit", nil).show()

local isLongClick = false

grid.onItemClick = function(l, v, position, id)
    if isLongClick then
        isLongClick = false
        return
    end
    
    local selectedName = v.getText()

    task(500, function()
        local languageCode = languageCodes[selectedName]
        service.callPhone(languageCode)
service.click({{"%Go back<2"}})
    end)
end

grid.onItemLongClick = function(l, v, position, id)
    isLongClick = true
local selectedName = v.getText()
require "import"
import "android.widget.*"
layout = {
LinearLayout;
orientation = "vertical";

{Button;
text = "OK";
onClick = function()
  local selectedName = v.getText()
  local file = File("/storage/emulated/0/解说/Plugins/Voice caller/Contact.lua")
  local reader = BufferedReader(FileReader(file))
  local lines = {}
  local line = reader.readLine()
  while (line ~= nil) do
    lines[#lines + 1] = line
    line = reader.readLine()
  end
  reader.close()

  local modifiedLines = {}
  for _, line in ipairs(lines) do
    if not line:find(selectedName, 1, true) then
      modifiedLines[#modifiedLines + 1] = line
    end
  end

  local fileWriter = FileWriter(file)
  for _, line in ipairs(modifiedLines) do
    fileWriter.write(line)
    fileWriter.write("\n")
  end
  fileWriter.close()

  Toast.makeText(this, selectedName .. " has been deleted", Toast.LENGTH_SHORT).show()
  dlg.dismiss()

end
}
}
dlg = LuaDialog(service)
dlg.setTitle(selectedName.. " என்ற தொடர்பை நீக்கவா?")
dlg.setButton("cancel",nil)
dlg.View = loadlayout(layout)
dlg.show()
end
end

return contact_window